'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _interval = require('./interval');

var _interval2 = _interopRequireDefault(_interval);

var _options = require('../options');

var _options2 = _interopRequireDefault(_options);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var USAGE = 'Usage: chunkify.range(Function fn, Number range, [Object options])';

var ok_usage = function ok_usage(fn, range) {
  if (!_underscore2['default'].isFunction(fn)) {
    throw new Error(USAGE + ' - bad fn; not a function');
  } else if (!_underscore2['default'].isNumber(range)) {
    throw new Error(USAGE + ' - bad range; not a number');
  }
};

var range = function range(fn, _range) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  ok_usage(fn, _range);
  delete options.start;
  return (0, _interval2['default'])(fn, _range, options);
};

exports['default'] = range;
module.exports = exports['default'];