'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var marked0$0 = [chunkify].map(regeneratorRuntime.mark);

var _options = require('./options');

var _options2 = _interopRequireDefault(_options);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

// Return values from the range `start` to `final` synchronously
// when between intervals of size `chunk`.
//
// On the chunk boundary, return a promise that resolves in `delay` milliseconds.
//
// An error will be thrown in case an iterator is advanced before a pending
// promise has resolved.
function chunkify(start, final, options) {
  var marked1$0, chunk, delay, paused, paused_error, pause, index;
  return regeneratorRuntime.wrap(function chunkify$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        pause = function pause() {
          return regeneratorRuntime.wrap(function pause$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
              case 0:
                context$2$0.next = 2;
                return new Promise(function (resolve) {
                  paused = true;
                  setTimeout(function () {
                    resolve();paused = false;
                  }, delay);
                });

              case 2:
              case 'end':
                return context$2$0.stop();
            }
          }, marked1$0[0], this);
        };

        marked1$0 = [pause].map(regeneratorRuntime.mark);
        chunk = options.chunk;
        delay = options.delay;
        paused = false;

        paused_error = function paused_error(index) {
          return new Error('paused at index ' + index + '; wait ' + delay + ' milliseconds before further invocations of .next()');
        };

        index = start;

      case 7:
        if (!(index < final)) {
          context$1$0.next = 17;
          break;
        }

        if (!(index > start && index % (start + chunk) === 0)) {
          context$1$0.next = 10;
          break;
        }

        return context$1$0.delegateYield(pause(), 't0', 10);

      case 10:
        if (!paused) {
          context$1$0.next = 12;
          break;
        }

        throw paused_error(index);

      case 12:
        context$1$0.next = 14;
        return index;

      case 14:
        index++;
        context$1$0.next = 7;
        break;

      case 17:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

exports['default'] = {
  from_keywords: function from_keywords(start, final) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    if (!_underscore2['default'].isNumber(start)) {
      throw new Error('start index `start` of generator range must be a number');
    } else if (!_underscore2['default'].isNumber(final)) {
      throw new Error('final index `final` of generator range must be a number');
    }
    return chunkify(start, final, _options2['default'].of(options));
  }
};
module.exports = exports['default'];